Utils.insertCSS ".dimmed {opacity: 0.4;}"

## GRID ##
grid.props =
	image: "images/gridlines.png"
	style:
		backgroundPosition: "0px 0px"
		backgroundRepeat: "repeat"
		backgroundSize: "auto"

## LAYER OUTLINE (NOT SCALED) ##
initialFrame = theLayer.frame

layerWithoutScale = new Layer
	frame: theLayer.frame
	backgroundColor: null
	parent: grid
	borderColor: "red"
	borderWidth: 0.5

## LINES + ORIGIN POINT ##
originXline = new Layer
	width: 1
	height: layerWithoutScale.height - 12
	backgroundColor: null
	x: (layerWithoutScale.width * layerWithoutScale.originX) - 1
	y: 6
	borderColor: "white"
	opacity: .7
	parent: layerWithoutScale
	borderWidth:
		left: 1

originYline = new Layer
	width: layerWithoutScale.width - 12
	height: 1
	backgroundColor: null
	x: 6
	y: (layerWithoutScale.height * layerWithoutScale.originY) - 1
	borderColor: "white"
	opacity: .7
	parent: layerWithoutScale
	borderWidth:
		top: 1

originPoint = new Layer
	size: 6
	borderRadius: 3
	backgroundColor: "white"
	x: (layerWithoutScale.width * layerWithoutScale.originX) - 3.5
	y: (layerWithoutScale.height * layerWithoutScale.originY) - 3.5
	opacity: .7
	parent: layerWithoutScale

## SLIDER LABELS + SLIDERS + SLIDER VALUES ##
slider_1_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>originX"

slider_1 = new SliderComponent 
	min: 0
	max: 1

slider_1.onValueChange -> 
	theLayer.originX = this.value
	layerWithoutScale.originX = this.value

slider_1_value = new Layer


slider_2_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>originY"

slider_2 = new SliderComponent 
	min: 0
	max: 1

slider_2.onValueChange -> 
	theLayer.originY = this.value
	layerWithoutScale.originY = this.value

slider_2_value = new Layer


slider_3_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>rotation"

slider_3 = new SliderComponent 
	min: 0
	max: 360

current_rotation = theLayer.rotation

slider_3.onValueChange -> 
	theLayer.rotation = this.value
	layerWithoutScale.rotation = this.value
	current_rotation = this.value

slider_3_value = new Layer


slider_4_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>scale"

slider_4 = new SliderComponent 
	min: 0
	max: 2

slider_4.onValueChange -> 
	theLayer.scale = this.value

slider_4_value = new Layer


slider_5_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>scaleX"

slider_5 = new SliderComponent 
	min: 0
	max: 2

slider_5.onValueChange -> 
	theLayer.scaleX = this.value

slider_5_value = new Layer


slider_6_label = new Layer
	html: "<span class=\"dimmed\">layer.</span>scaleY"

slider_6 = new SliderComponent 
	min: 0
	max: 2

slider_6.onValueChange -> 
	theLayer.scaleY = this.value

slider_6_value = new Layer

allLabels = [slider_1_label, slider_2_label, slider_3_label, slider_4_label, slider_5_label, slider_6_label]
allSliders = [slider_1, slider_2, slider_3, slider_4, slider_5, slider_6]
allValues = [slider_1_value, slider_2_value, slider_3_value, slider_4_value, slider_5_value, slider_6_value]

# Loop over all sliders, their labels, and values
for i in [0..5]
	# Labels
	allLabels[i].props =
		width: 165
		height: 70
		backgroundColor: null
		x: 50
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"
	
	# Sliders
	allSliders[i].props =
		width: 420
		height: 5
		x: allLabels[i].maxX + 15
		y: grid.maxY + 45 + (i*50)
	
	allSliders[i].fill.backgroundColor = "rgba(255,255,255,0.7)"
	allSliders[i].knobSize = 25
	allSliders[i].knob.borderRadius = 13
	allSliders[i].knob.backgroundColor = "rgba(255,255,255,1)"
	allSliders[i].backgroundColor = "rgba(255,255,255,0.3)"
	
	# Values
	allValues[i].props =
		width: 50
		height: 25
		backgroundColor: null
		x: allSliders[i].maxX + 20
		y: grid.maxY + 40 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

## RESET BUTTON ##
button_reset = new Layer
	width: 200
	height: 40
	borderRadius: 25
	backgroundColor: "white"
	x: Screen.width - 200 - 45
	maxY: Screen.height - 45
	color: "black"
	html: "Reset layer"
	style:
		fontFamily: Title.fontFamily
		fontWeight: 300
		fontSize: "22px"
		lineHeight: "76px"
		textAlign: "center"

button_reset.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_reset.onTap ->
	@backgroundColor = "white"
	theLayer.animate
		originX: 0.5
		originY: 0.5
		rotation: 0
		scale: 1
		scaleX: 1
		scaleY: 1
	layerWithoutScale.animate
		originX: 0.5
		originY: 0.5
		rotation: 0

## EVENTS ##
layerWithoutScale.on "change:originX", ->
	slider_1.value = this.originX
	slider_1_value.html = "#{Utils.round this.originX, 2}"
	originXline.x = (this.width * this.originX) - 1
	originPoint.x = (this.width * this.originX) - 4

layerWithoutScale.on "change:originY", ->
	slider_2.value = this.originY
	slider_2_value.html = "#{Utils.round this.originY, 2}"
	originYline.y = (this.height * this.originY) - 1
	originPoint.y = (this.height * this.originY) - 4

theLayer.on "change:rotation", ->
	layerWithoutScale.rotation = this.rotation
	slider_3.value = this.rotation
	slider_3_value.html = "#{Utils.round this.rotation}"

theLayer.on "change:scale", ->
	slider_4.value = this.scale
	slider_4_value.html = "#{Utils.round this.scale, 2}"

theLayer.on "change:scaleX", ->
	slider_5.value = this.scaleX
	slider_5_value.html = "#{Utils.round this.scaleX, 2}"

theLayer.on "change:scaleY", ->
	slider_6.value = this.scaleY
	slider_6_value.html = "#{Utils.round this.scaleY, 2}"

# After loading
slider_1.value = theLayer.originX
slider_1_value.html = "#{Utils.round theLayer.originX, 2}"
slider_2.value = theLayer.originY
slider_2_value.html = "#{Utils.round theLayer.originY, 2}"
slider_3.value = theLayer.rotation
slider_3_value.html = "#{theLayer.rotation}"
slider_4.value = theLayer.scale
slider_4_value.html = "#{Utils.round theLayer.scale, 2}"
slider_5.value = theLayer.scaleX
slider_5_value.html = "#{Utils.round theLayer.scaleX, 2}"
slider_6.value = theLayer.scaleY
slider_6_value.html = "#{Utils.round theLayer.scaleY, 2}"
